var system_timezone_offset = '{{SYSTEM_TIMEZONE_OFFSET}}';
var user_timezone = "{{USER.timezone}}";
var is_nicescroll = true;

if ($("body").hasClass("chat-scroll")) {
    var previous_height = $('.chat-scroll')[0].scrollHeight;
}
(function($) {
    "use strict";

    $(document).ready(function() {
        // Initialize summernote wysiwyg editor
        $('.summernote').summernote();
        $(".dob").dateDropdowns();
        $('#dataTable').DataTable({
            stateSave: true
        });

        //Init lazy Load
        $(function() {
            $('.lazy').Lazy();
        });
        var page_reload = false;

        if ($(".chat-scroll").length > 0){
            $(".emoji-area").emojioneArea({
                events: {
                    ready: function (editor, event) {
                        var from_user = $("#from_user").val();
                        var active_user = $("#active_user").val();
                        var active_group = $("#active_group").val();
                        var active_room = $("#active_room").val();

                        loadChats(from_user, active_user, active_group, active_room);
                    }
                }
            });

            // $(".emoji-area").emojioneArea();

        }

        // Whenever user click on Update button on settings page, call ajax with new settings
        $(".update-settings").on('click', function(e) {
            var update_type = $(this).val();
            var data = new FormData($('#'+$(this).val())[0]);
            data.append("update_type", $(this).val());
            {{ csrf_token }}
            if(update_type == "policy-settings"){
                data.set('terms_and_conditions', $('#terms_and_conditions').summernote('code'));
                data.set('privacy_policy', $('#privacy_policy').summernote('code'));
            }
            if(update_type == "about-settings"){
                data.set('about_us', $('#about_us').summernote('code'));
            }
            $('.settings-success').hide();
            $('.settings-error').hide();
            $.ajax({
                url: "{{ url('ajax-update-settings') }}",
                data: data,
                type: "POST",
                dataType: 'json',
                contentType: false,
                processData: false,
                enctype: 'multipart/form-data',
                beforeSend: function() {
                    loading(".card-"+update_type, "show");
                },
                success: function(data) {
                    page_reload = true;
                    $('.text-error').remove();
                    if(data.success) {
                        toastr["success"]("{{_('Successfully Updated')}}");
                    }else{
                        $.each( data.message, function( key, field_array ) {
                            $.each( field_array, function( field, error_list ) {
                                $.each( error_list, function( error_key, error_message ) {
                                    $('[name='+field+']').after(`<small class="form-text text-danger text-error">`+error_message+`</small>`);
                                });
                            });
                        });
                    }
                },complete: function(){
                    loading(".card-"+update_type, "hide");
                }
            });

        });

        // Generate image instant previews
        $(document).on("change",".upload-setting-image", function(){
            var uploadFile = $(this);
            var files = !!this.files ? this.files : [];
            if (!files.length || !window.FileReader) return; // no file selected, or no FileReader support

            if (/^image/.test( files[0].type)){ // only image file
                var reader = new FileReader(); // instance of the FileReader
                reader.readAsDataURL(files[0]); // read the local file
                reader.onloadend = function(){ // set image data as background of div
                    uploadFile.closest(".row").find(".setting-image-preview").html("");
                    uploadFile.closest(".row").find(".setting-image-preview").css("background-image", "url("+this.result+")");

                }
            }
        });

        // Update Chat Room information with ajax
        $(document).on("click", '.admin-update-chatroom', function(event) {
            var data = new FormData($('#admin-chatroom-info')[0]);
            $('.chatroom-success').hide();
            $('.chatroom-error').hide();
            $.ajax({
                url: "{{ url('ajax-update-chatroom') }}",
                data: data,
                type: "POST",
                dataType: 'json',
                contentType: false,
                processData: false,
                enctype: 'multipart/form-data',
                beforeSend: function() {
                    loading(".card-room-info", "show");
                },
                success: function(data) {
                    $('.text-error').remove();
                    if(data.success == "true") {
                        toastr.success(
                            "{{_('Successfully Updated')}}", '',
                            {
                                timeOut: 3000,
                                fadeOut: 3000,
                                onHidden: function () {
                                    window.location.href = "{{ url('dashboard-chatroom-list') }}";
                                }
                            }
                        );
                    }else{
                        $.each( data.message, function( key, field_array ) {
                            $.each( field_array, function( field, error_list ) {
                                $.each( error_list, function( error_key, error_message ) {
                                    $('[name='+field+']').after(`<small class="form-text text-danger text-error">`+error_message+`</small>`);
                                });
                            });
                        });
                    }

                },complete: function(){
                    loading(".card-room-info", "hide");
                }
            });

            $('a[data-toggle="pill"]').on('shown.bs.tab', function (e) {

                $('.chatroom-success').hide();
                $('.chatroom-error').hide();
            });
        });

        // Change cover image of chat room preveiw
        $(document).on("change",".upload-cover-image", function(){
            var uploadFile = $(this);
            var files = !!this.files ? this.files : [];
            if (!files.length || !window.FileReader) return; // no file selected, or no FileReader support

            if (/^image/.test( files[0].type)){ // only image file
                var reader = new FileReader(); // instance of the FileReader
                reader.readAsDataURL(files[0]); // read the local file
                reader.onloadend = function(){ // set image data as background of div
                    uploadFile.closest(".row").find(".room-coverimage-preview img").attr("src",this.result);
                }
            }
        });

        // Update already created chat room
        $(document).on("click", ".edit-chatroom, .new-chatroom", function(){
            var edit_id = $(this).attr("data-edit-id");
            $.ajax({
                url: "{{ url('ajax-get-chatroom') }}",
                data: {
                    edit_room: edit_id,
                    csrftoken: '{{ csrf_token_ajax() }}'
                },
                type: "POST",
                beforeSend: function() {
                    loading(".card-room-users", "show");
                },
                success: function(data) {
                    $('.rooms-modal .modal-body').html(data);
                    $('.rooms-modal').modal('show');
                    $('#dataTable').DataTable();
                },
                complete: function(){
                    loading(".card-room-users", "hide");
                }
            });
        });

        // delete chatroom
        $(document).on('click', '.delete-chatroom', function(e) {
            var room_id = this.id;
            if (confirm('{{_("Are you sure you want to delete this room? This action can not be undone.")}}')) {
                $.ajax({
                    url: "{{ url('ajax-delete-chatroom') }}",
                    type: "POST",
                    dataType: 'json',
                    data: {
                        csrftoken: '{{ csrf_token_ajax() }}',
                        room_id: room_id
                    },
                    beforeSend: function() {
                        loading(".card-room-list","show");
                    },
                    success: function(data) {
                        if(data.success){
                            toastr["success"]("{{_('Successfully deleted')}}");
                            $('#dataTable').DataTable().row($('#'+room_id).closest('tr')).remove().draw();
                        }
                    },complete: function(){
                        loading(".card-room-list","hide");
                    }

                });
            }
        });

        // delete chats
        $(document).on('click', '.delete-chats', function(e) {
            var room_id = this.id;
            if (confirm('{{_("Are you sure you want to delete all chats on this room? This action can not be undone.")}}')) {
                $.ajax({
                    url: "{{ url('ajax-delete-chats') }}",
                    type: "POST",
                    dataType: 'json',
                    data: {
                        csrftoken: '{{ csrf_token_ajax() }}',
                        room_id: room_id
                    },
                    beforeSend: function() {
                        loading(".card-room-list","show");
                    },
                    success: function(data) {
                        if(data.success){
                            toastr["success"]("{{_('Successfully deleted')}}");
                        }
                    },complete: function(){
                        loading(".card-room-list","hide");
                    }

                });
            }
        });

        // Update and manage users in chat rooms (kick and unkick)
        $(document).on("click", ".chatroom-user-restriction", function(){
            var result = confirm("Are you sure?");
            if (result) {
                var current_row = $(this).closest('tr');
                var room_id = $(this).attr("data-room");
                var selected_user = $(this).attr("data-user");
                var restriction_type = $(this).attr("data-restriction-type");
                $.ajax({
                    url: "{{ url('ajax-chatroom-user-restriction') }}",
                    data: {room_id : room_id, selected_user : selected_user, restriction_type : restriction_type,
                    csrftoken: '{{ csrf_token_ajax() }}'
                    },
                    type: "POST",
                    beforeSend: function() {
                        loading(".card-room-users", "show");
                    },
                    success: function(data) {
                        if(restriction_type == "3"){
                            $(current_row).find('.kick-btn').css("display", "none");
                            $(current_row).find('.unkick-btn').css("display", "block");
                        }else if (restriction_type == "1") {
                            $(current_row).find('.kick-btn').css("display", "block");
                            $(current_row).find('.unkick-btn').css("display", "none");
                        }

                        if(data.success == "true") {
                            $('.chatroom-success').html(data.message);
                            $('.chatroom-success').show();
                        }else{
                            $('.chatroom-error').html(data.message);
                            $('.chatroom-error').show();
                        }
                    },
                    complete: function(){
                        loading(".card-room-users", "hide");
                    }
                });
            }
        });

        // Whenever user click on Update button on language page, call ajax with new settings
        $(document).on("click", ".update-language", function(){
            var data = new FormData($('#language-form')[0]);
            $('.language-error').hide();
            $.ajax({
                url: "{{ url('ajax-language-update') }}",
                data: data,
                type: "POST",
                cache: false,
                contentType: false,
                processData: false,
                beforeSend: function() {
                    loading(".card-language", "show");
                },
                success: function(data) {
                    page_reload = true;
                    $('.text-error').remove();
                    if(data.success) {
                        toastr.success(
                            "{{_('Successfully Updated')}}", '',
                            {
                                timeOut: 3000,
                                fadeOut: 3000,
                                onHidden: function () {
                                    window.location.href = "{{ url('dashboard-languages') }}";
                                }
                            }
                        );
                    }else{
                        $.each( data.message, function( key, field_array ) {
                            $.each( field_array, function( field, error_list ) {
                                $.each( error_list, function( error_key, error_message ) {
                                    $('[name='+field+']').after(`<small class="form-text text-danger text-error">`+error_message+`</small>`);
                                });
                            });
                        });
                    }
                },complete: function(){
                    loading(".card-language", "hide");
                }
            });

        });

        // Whenever user click on Update translation on translation page
        $(document).on("click", ".update-translation", function(){
            var data = new FormData($('#lang-translation')[0]);
            $.ajax({
                url: "{{ url('ajax-update-translation') }}",
                data: data,
                type: "POST",
                cache: false,
                contentType: false,
                processData: false,
                beforeSend: function() {
                    loading(".card-language", "show");
                },
                success: function(data) {
                    page_reload = true;
                    $('.text-error').remove();
                    if(data.success) {
                        toastr.success(
                            "{{_('Successfully Updated')}}", '',
                            {
                                timeOut: 3000,
                                fadeOut: 3000,
                            }
                        );
                    }else{
                        $.each( data.message, function( key, field_array ) {
                            $.each( field_array, function( field, error_list ) {
                                $.each( error_list, function( error_key, error_message ) {
                                    $('[name='+field+']').after(`<small class="form-text text-danger text-error">`+error_message+`</small>`);
                                });
                            });
                        });
                    }
                },complete: function(){
                    loading(".card-language", "hide");
                }
            });

        });

        // Update and manage users in chat rooms (kick and unkick)
        $(document).on("click", ".delete-language", function(){
            var result = confirm("Are you sure?");
            if (result) {
                var lang = $(this).attr("data-lang");
                $.ajax({
                    url: "{{ url('ajax-language-delete') }}",
                    data: {lang : lang, csrftoken: '{{ csrf_token_ajax() }}'},
                    type: "POST",
                    beforeSend: function() {
                        loading(".card-language-list", "show");
                    },
                    success: function(data) {
                        if(data.success == true) {
                            toastr.success(
                                "{{_('Successfully deleted')}}", '',
                                {
                                    timeOut: 3000,
                                    fadeOut: 3000,
                                    onHidden: function () {
                                        window.location.href = "{{ url('dashboard-languages') }}";
                                    }
                                }
                            );
                        }else{
                            $('.language-error').html(data.message);
                            $('.language-error').show();
                        }
                    },
                    complete: function(){
                        loading(".card-language-list", "hide");
                    }
                });
            }
        });

        $(document).on('change', '#is_protected', function() {
            if(this.checked) {
                $('.pin-area').show();
            }else{
                $('.pin-area').hide();
            }
        });

        $(document).on('change', '#single_room_mode', function() {
            if($(this).val() == 1) {
                $('.default-room-area').show();
            }else{
                $('.default-room-area').hide();
            }
        });

        $(document).on('change', '#enable_terms', function() {
            if($(this).val() == 1) {
                $('.enable-terms-area').show();
            }else{
                $('.enable-terms-area').hide();
            }
        });

        $(document).on('change', '#enable_privacy', function() {
            if($(this).val() == 1) {
                $('.enable-privacy-area').show();
            }else{
                $('.enable-privacy-area').hide();
            }
        });

        $(document).on('change', '#enable_about', function() {
            if($(this).val() == 1) {
                $('.enable-about-area').show();
            }else{
                $('.enable-about-area').hide();
            }
        });

        $(document).on('change', '#profanity_filter', function() {
            if($(this).val() == 1) {
                $('.enable-profanity-area').show();
            }else{
                $('.enable-profanity-area').hide();
            }
        });

        $(document).on('change', '#enable_files', function() {
            if($(this).val() == 1) {
                $('.enable-filelist-area').show();
            }else{
                $('.enable-filelist-area').hide();
            }
        });

        $(document).on('change', '#enable_contact', function() {
            if($(this).val() == 1) {
                $('.enable-contact-area').show();
            }else{
                $('.enable-contact-area').hide();
            }
        });

        $(document).on('change', '#cookie_consent_popup', function() {
            if($(this).val() == 1) {
                $('.cookie-message-area').show();
            }else{
                $('.cookie-message-area').hide();
            }
        });

        $(document).on('change', '#theme', function() {
            if($(this).val() == 'custom') {
                $('.custom-colors').show();
            }else{
                $('.custom-colors').hide();
            }
        });

        $(document).on('change', '.trans-lang-switch', function() {
            window.location.href = "{{ url('dashboard-language-translation') }}?lang="+$(this).val();
        });

        $(document).on('change', '.check_all', function() {
            $('.user-selection, .check_all').prop('checked', this.checked);
        });

        $(document).on('click', '.delete-user', function(e) {
            var selected = $(this).attr('data-id');
            $('#'+selected).prop('checked', 'checked');
            $(".delete-selected-user").trigger("click");
        });

        $(document).on('click', '.delete-selected-user', function(e) {
            var result = confirm("Are you sure?");
            if (result) {
                var data = new FormData($('#user-list')[0]);
                var url = "{{url('ajax-delete-users')}}";
                $.ajax({
                    url: url,
                    data: data,
                    type: "POST",
                    dataType: 'json',
                    cache: false,
                    contentType: false,
                    processData: false,
                    success: function(data) {
                        if (data.success == true) {
                            toastr.success(
                                "{{_('Successfully deleted')}}", '',
                                {
                                    timeOut: 1500,
                                    fadeOut: 1500,
                                    onHidden: function () {
                                        window.location.reload();
                                    }
                                }
                            );
                        } else {
                            toastr["error"]("{{_('Something went wrong')}}");
                        }
                    },
                });
            }
        });

        $('.color-picker').on('input', function() {
            $(this).siblings("input[type=text]").val($(this).val());
        });

        $('.color-input').on('input', function() {
            $(this).siblings('.color-picker').val($(this).val());
        });


        // click recent room chat or individual chat
        $(document).on('click', '.recent-chat', function(e) {
            $('.recent-chat').removeClass('active');
            $(this).addClass('active');
            var from_user = $("#from_user").val();
            var active_user = $(this).data("user-id");
            var active_group = $("#active_group").val();
            var active_room = $("#active_room").val();

            loadChats(from_user, active_user, active_group, active_room);
        });

        // chat area scroll
        $('.chat-scroll').scroll(function() {
            if($('.chat-scroll').scrollTop() == 0){
                previous_height = $('.chat-scroll')[0].scrollHeight;
                load_more_chats();
            }
        });

        // delete message
        $(document).on('click', '.message-delete', function(e) {
            var message_id = $(this).parent().parent().attr('id');
            var chat_type = $(this).data("chat-type");
            $.ajax({
                url: "{{ url('ajax-delete-message') }}",
                type: "POST",
                dataType: 'json',
                data: {
                    csrftoken: '{{ csrf_token_ajax() }}',
                    message_id: message_id,
                    chat_type: chat_type
                },
                beforeSend: function() {
                    loading(".messages","show");
                },
                success: function(data) {
                    if(data.success){
                        $('#'+message_id).find('.message-html').html(`<div class="chat-txt deleted"><i class="fa fa-ban"></i> This message was deleted</div>`);
                        $('#'+message_id).find('.chat-actions').html(``);
                        $('#'+message_id).find('.message-status').html(``);
                    }
                },complete: function(){
                    loading(".messages","hide");
                }

            });
        });

        $(".save-profile").on('click', function(e) {
            var data = new FormData($('#profile-form')[0]);
            var url = "{{url('ajax-save-profile')}}";
            $('.profile-error').hide();
            $.ajax({
                url: url,
                data: data,
                type: "POST",
                dataType: 'json',
                cache: false,
                contentType: false,
                processData: false,
                enctype: 'multipart/form-data',
                success: function(data) {

                    $('.text-error').remove();
                    if (data.success == true) {
                        toastr["success"]("{{_('Successfully Updated')}}");
                    } else {
                        if ($.isArray(data.message)) {
                            $.each(data.message, function(key, field_array) {
                                $.each(field_array, function(field, error_list) {
                                    $.each(error_list, function(error_key, error_message) {
                                        $('[name=' + field + ']').after(`<small class="form-text text-danger text-error">` + error_message + `</small>`);
                                    });
                                });
                            });
                        } else {
                            $('.profile-error').html(data.message);
                            $('.profile-error').show();
                        }
                    }
                },
            });
        });

        $(".add-profile").on('click', function(e) {
            var data = new FormData($('#profile-form')[0]);
            var url = "{{url('ajax-add-profile')}}";
            $('.profile-error').hide();
            $.ajax({
                url: url,
                data: data,
                type: "POST",
                dataType: 'json',
                cache: false,
                contentType: false,
                processData: false,
                enctype: 'multipart/form-data',
                success: function(data) {

                    $('.text-error').remove();
                    if (data.success == true) {
                        toastr.success(
                            "{{_('Successfully added')}}", '',
                            {
                                timeOut: 3000,
                                fadeOut: 3000,
                                onHidden: function () {
                                    window.location.href = "{{ url('dashboard-user-list') }}";
                                }
                            }
                        );
                    } else {
                        if ($.isArray(data.message)) {
                            $.each(data.message, function(key, field_array) {
                                $.each(field_array, function(field, error_list) {
                                    $.each(error_list, function(error_key, error_message) {
                                        $('[name=' + field + ']').after(`<small class="form-text text-danger text-error">` + error_message + `</small>`);
                                    });
                                });
                            });
                        } else {
                            $('.profile-error').html(data.message);
                            $('.profile-error').show();
                        }
                    }
                },
            });
        });


        // profile image upload
        $(document).on("change", ".upload-image", function() {
            var uploadFile = $(this);
            var files = !!this.files ? this.files : [];
            if (!files.length || !window.FileReader) return; // no file selected, or no FileReader support

            if (/^image/.test(files[0].type)) { // only image file
                var reader = new FileReader(); // instance of the FileReader
                reader.readAsDataURL(files[0]); // read the local file
                reader.onloadend = function() { // set image data as background of div
                    uploadFile.closest(".imgUp").find('.imagePreview').html("");
                    uploadFile.closest(".imgUp").find('.imagePreview').css("background-image", "url(" + this.result + ")");
                }
            }
        });

        $('.select2').select2({
            theme: 'bootstrap4'
        });
    });


})(jQuery);

"use strict";
function loadChats(from_user, active_user, active_group, active_room){
    $(".chats").empty();
    $("#active_user").val(active_user);
    $("#active_group").val(active_group);
    $("#active_room").val(active_room);
    $.ajax({
        url: "{{ url('dashboard-load-chats') }}",
        type: "POST",
        dataType: 'json',
        data: {
            csrftoken: '{{ csrf_token_ajax() }}',
            from_user: from_user,
            active_user: active_user,
            active_group: active_group,
            active_room: active_room
        },
        beforeSend: function() {
            loading(".messages","show");
        },
        success: function(data) {
            $("#last_chat_id").val(0);
            $.each(data.chats, function( index, obj ) {
                createMessage(obj, from_user);
                $("#last_chat_id").val(obj.id);
            });

            $("#chat_meta_id").val(data.chat_meta_id);
            $("#last_updated_chat_time").val(data.last_updated_chat_time);
        },complete: function(){
            loading(".messages","hide");
            lazyLoad();
            $('.chat-scroll').scrollTop($('.chat-scroll')[0].scrollHeight);
        }

    });
}

// message create and append to the chat container
function createMessage(obj, from_user, more_chats=false, save_message=false){
    var sender_div = "";
    var is_group = "";
    var msg_delete_btn = "";
    if (obj.sender_id == from_user ) {
        var message_class_name = "sent";
        var msg_status = '<i class="fa fa-check-double"></i>';
        var msg_status_class = '';
        if (obj.status == 2) {
            msg_status_class = 'read';
        }
        if (obj.status != 3) {
            msg_delete_btn = `<i class="fa fa-trash-alt message-delete" data-chat-type="`+obj.chat_type+`" title="Delete"></i>`;
        }
    }else{
        var message_class_name = "replies";
        var msg_status = '';
        var msg_status_class = '';
        if(obj.chat_type == "group"){
            is_group = "grp";
            sender_div = "<small>"+obj.first_name +" </small>";
        }
        if ({{ USER.user_type }} == 1 && obj.status != 3){
            msg_delete_btn = `<i class="fa fa-trash-alt message-delete" data-chat-type="`+obj.chat_type+`" title="Delete"></i>`;
        }
    }

    if(!obj.random_id){
        obj.random_id = "";
    }

    if(obj.avatar) {
        var img_src = "{{MEDIA_URL}}/avatars/"+obj.avatar;
    }else{
        var img_src = "{{STATIC_URL}}/img/user.jpg";
    }
    var msg = "";

    if(obj.status != 3){
        if(obj.type == 1){
            msg = (emojione.shortnameToImage(linkParse(htmlEncode(obj.message))));
            msg = `<div class="chat-txt">`+msg+`</div>`;
        }else if(obj.type == 2){
            var images = JSON.parse(obj.message);
            if (images.length > 2) {
                msg = `<div class="chat-img-grp chat-gallery" data-pswp-uid="1">`;
                var n = 1;
                var more_overlay = "";
                var each_img = "";
                $.each(JSON.parse(obj.message), function(img_idx, img_obj) {
                    var image_size_str = img_obj.split('_');
                    var image_size = "600x600";
                    if (image_size_str[1] !== undefined) {
                        image_size = image_size_str[1].substring(0, image_size_str[1].indexOf("."))
                    }
                    if (n > 3) {
                        var cls = "chat-img d-none";
                    }else if (n == 3) {
                        if (images.length - 2 != 1)  {
                            var cls = "chat-img more";
                            more_overlay = `<span class="more-ovrlay">+`+(images.length - 3).toString()+`</span>`;
                        }else{
                            var cls = "chat-img";
                        }
                    }else{
                        var cls = "chat-img";
                    }
                    each_img = `<figure class="`+cls+`">
                                    <a href="{{MEDIA_URL}}/chats/images/large/`+img_obj+`" data-size="`+image_size+`">
                                        <img class="lazy" data-src="{{MEDIA_URL}}/chats/images/thumb/`+img_obj+`" />
                                        `+more_overlay+`
                                    </a>
                                </figure>`;
                    msg = msg + each_img;
                    n++;
                });
                msg = msg + "</div>";
            }else if (images.length == 2) {
                msg = `<div class="chat-img-duo chat-gallery" data-pswp-uid="1"">`;
                $.each(JSON.parse(obj.message), function(img_idx, img_obj) {
                    var image_size_str = img_obj.split('_');
                    var image_size = "600x600";
                    if (image_size_str[1] !== undefined) {
                        image_size = image_size_str[1].substring(0, image_size_str[1].indexOf("."))
                    }
                    each_img = `<figure >
                                    <a href="{{MEDIA_URL}}/chats/images/large/`+img_obj+`" data-size="`+image_size+`">
                                        <img class="lazy"  data-src="{{MEDIA_URL}}/chats/images/thumb/`+img_obj+`" />
                                    </a>
                                </figure>`;
                    msg = msg + each_img;
                });
                msg = msg + "</div>";
            }else{
                msg = `<div class="chat-img-sgl chat-gallery" data-pswp-uid="1"">`;
                $.each(JSON.parse(obj.message), function(img_idx, img_obj) {
                    var image_size_str = img_obj.split('_');
                    var image_size = "600x600";
                    if (image_size_str[1] !== undefined) {
                        image_size = image_size_str[1].substring(0, image_size_str[1].indexOf("."))
                    }
                    var image_size_px = image_size.split('x');
                    if(image_size_px[0] >= 150){
                        var thumb_width = '150px';
                    }else{
                        var thumb_width = image_size_px[0]+'px';
                    }
                    if(image_size_px[1] >= 150){
                        var thumb_height = '150px';
                    }else{
                        var thumb_height = image_size_px[0]+'px';
                    }
                    each_img = `<figure>
                                    <a href="{{MEDIA_URL}}/chats/images/large/`+img_obj+`" data-size="`+image_size+`">
                                        <img width="`+thumb_width+`" height="`+thumb_height+`" class="lazy" data-src="{{MEDIA_URL}}/chats/images/thumb/`+img_obj+`" src="" />
                                    </a>
                                </figure>`;
                    msg = msg + each_img;
                });
                msg = msg + "</div>";
            }

        }else if(obj.type == 3){
            msg = `<div class="chat-gif"> <img class="lazy" data-src="`+obj.message+`" /> </div>`;
        }else if (obj.type == 4){
            msg = `<div class="chat-sticker"> <img  class="lazy" data-src={{MEDIA_URL}}/stickers/`+encodeURI(obj.message)+` /> </div>`;
        }
    }else{
        msg_status = "";
        msg = `<div class="chat-txt deleted"><i class="fa fa-ban"></i> This message was deleted</div>`;
    }

    var new_chat_date = moment(obj.time+system_timezone_offset).tz(user_timezone).format('dddd, MMM D, YYYY');
    var msg_content = `<li class="`+message_class_name+`" id="`+obj.id+`" data-random-id="`+obj.random_id+`" data-date="`+new_chat_date+`">
                            <img class="avatar lazy" data-src="`+img_src+`"  />
                            <div class="message-data `+is_group+`">
                                `+sender_div+`
                                <div class="message-html">`+ msg +`</div>
                            </div>
                            <span class="message-meta">
                                <span class="message-time">`+ moment(obj.time+system_timezone_offset).tz(user_timezone).format('hh:mm A') +`</span>
                                <span class="message-status `+msg_status_class+`">`+ msg_status +`</span>
                            </span>
                            <div class="chat-actions">
                                `+ msg_delete_btn +`
                            </div>
                        </li>`;

    if(more_chats){
        $(msg_content).prependTo($('.message-card-body ul'));
    }else{
        $(msg_content).appendTo($('.message-card-body ul'));
    }
    $(".message-card-body ul").find(`[data-printed-date='`+new_chat_date+`']`).remove();
    $(".message-card-body ul").find(`[data-date='`+new_chat_date+`']:first`).before(`<li class="new-date" data-printed-date="`+new_chat_date+`"><p>`+new_chat_date+`</p></li>`);


    if(save_message){
        $('.chat-scroll').scrollTop($('.chat-scroll')[0].scrollHeight);
    }else if (more_chats) {
        $('.chat-scroll').scrollTop($('.chat-scroll')[0].scrollHeight - previous_height);
    }else if($('.chat-scroll')[0].scrollHeight - $('.chat-scroll').scrollTop() - $('.chat-scroll').height() < 350){
        $('.chat-scroll').scrollTop($('.chat-scroll')[0].scrollHeight);
    }
    chat_date = new_chat_date;
}

// load more chats
function load_more_chats(){
    var from_user = $("#from_user").val();
    var active_user = $("#active_user").val();
    var active_group = $("#active_group").val();
    var active_room = $("#active_room").val();
    $.ajax({
        url: "{{ url('dashboard-load-more-chats') }}",
        type: "POST",
        dataType: 'json',
        data: {
            csrftoken: '{{ csrf_token_ajax() }}',
            from_user: from_user,
            active_user: active_user,
            active_group: active_group,
            active_room: active_room
        },
        beforeSend: function() {
            loading(".messages","show");
        },
        success: function(data) {
            $.each(data.chats, function( index, obj ) {
                createMessage(obj, from_user, true);
            });

        },complete: function(){
            loading(".messages","hide");
            lazyLoad();
        }

    });
}

// Convert text links to hyperlinks in chat
function linkParse(inputText) {
    var replacedText, replacePattern1, replacePattern2, replacePattern3;

    //URLs starting with http://, https://, or ftp://
    replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
    replacedText = inputText.replace(replacePattern1, '<a href="$1" target="_blank"><span class="chat-link"><i class="fa fa-link"></i> $1</span></a>');

    //URLs starting with "www." (without // before it, or it'd re-link the ones done above).
    replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
    replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" target="_blank"><span class="chat-link"><i class="fa fa-link"></i> $2</span></a>');

    //Change email addresses to mailto:: links.
    replacePattern3 = /(([a-zA-Z0-9\-\_\.])+@[a-zA-Z\_]+?(\.[a-zA-Z]{2,6})+)/gim;
    replacedText = replacedText.replace(replacePattern3, '<a href="mailto:$1"><span class="chat-link"><i class="fa fa-link"></i> $1</span></a>');

    return replacedText;
}

// Convert html chars
function htmlEncode(html) {
    return document.createElement('a').appendChild(
        document.createTextNode(html)).parentNode.innerHTML;
}

// Lazy load images and scroll resize
function lazyLoad(){
    $('.lazy').lazy({
        effect: "fadeIn",
        effectTime: 500,
        scrollDirection: 'vertical',
        appendScroll:$('.chat-scroll'),
    });
    if (is_nicescroll) {
        $(".chat-scroll").getNiceScroll().resize();
    }
}
